
#include "korners_socket.h"
#include "korners_protocol.h"

#include <KDebug>
#include <QTimerEvent>


KornersSocket::KornersSocket( KornersProtocol* proto, QObject* parent ) : QTcpSocket( parent )
{
    m_proto = proto;
    m_attempts = 0;
    connect( this, SIGNAL(readyRead()), SLOT( bytesReceived()) );
}

void KornersSocket::connectTo( QString ip_adress, int port )
{
    m_peer_ip = ip_adress;
    m_port = port;        
    connectToHost( m_peer_ip, port );
    if( QObject::startTimer(500) == 0 )
        kDebug() << "failed to start connection timer";
}

void KornersSocket::timerEvent( QTimerEvent* event )
{   
    if( m_attempts == 4 )
    {
        kDebug() << "connection failed";
        killTimer( event->timerId() );
        emit( connectionFailed() );
    }

    if( state() == QAbstractSocket::ConnectedState )
    {
        killTimer( event->timerId() );
        return;
    }
    else
    {
        m_attempts++;
        connectToHost( m_peer_ip, m_port );
    }
}

void KornersSocket::bytesReceived()
{
    kDebug() << "bytes received";
    
    QDataStream in(this);
    in.setVersion(QDataStream::Qt_4_0);

    QByteArray msg;
    in >> msg;
    m_proto->processMessage( msg );
}

void KornersSocket::send(const QByteArray& pack)
{
    QDataStream str;
    str.setDevice(this);
    str << pack;
}
