
#ifndef KORNERS_SOCKET
#define KORNERS_SOCKET

#include <QTcpSocket>
#include <QString>

class KornersProtocol;


class KornersSocket : public QTcpSocket
{
    Q_OBJECT
public:
    KornersSocket( KornersProtocol* proto, QObject* parent = 0 ); 

    void send(const QByteArray& );
    void connectTo(QString ip_adress, int port);

public slots:
    void bytesReceived();

signals:
    void connectionFailed();

protected:
    void timerEvent( QTimerEvent*  );

private:   
    /**
     *  Network adress and port for network game
     */
    QString m_peer_ip;
    int m_port;
    /**
     *  Protocol class pointer
     */                  
    KornersProtocol* m_proto;
    /**
     *  Current number of connection attempts
     */
    int m_attempts;
};

#endif