
#include "korners_time_line.h"

#include <QDebug>


KornersTimeLine::KornersTimeLine()
{
    m_tml.setCurveShape( QTimeLine::LinearCurve );
    m_tml.setDirection( QTimeLine::Forward );

    connect( &m_tml, SIGNAL( frameChanged(int) ), SLOT( gotNewFrame(int) ) );
    connect( &m_tml, SIGNAL( finished() ), SLOT( tmlFinished() ) );

    m_running = false;
}

void KornersTimeLine::startFrames(int nFrames)
{
    m_tml.setCurrentTime(0);
    m_tml.setDuration( nFrames*500 );
    m_tml.setFrameRange( 0, nFrames );

    m_running = true;
    m_tml.start();
}

void KornersTimeLine::gotNewFrame(int nFrame)
{
    emit newFrame( nFrame );
}

void KornersTimeLine::tmlFinished()
{
    m_running = false;
    emit( finished() );
}

bool KornersTimeLine::running()
{
    return m_running;
}
