
#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

#include <KXmlGuiWindow>
#include <QTime>


class KornersWidget;

class KornersMainWindow : public KXmlGuiWindow
{
    Q_OBJECT
public:
    KornersMainWindow();
    ~KornersMainWindow() {}

protected:
    void setupActions();

private slots:
    void startGame();
    void viewHighScore();
    void gameOver( QTime );
    void gameStarted();
    void onTimeToggled(bool onTime);
    void configureSettings();
    void loadSettings();
    void createNetworkGame();
    void connectToNetworkGame();
    void playerName( QString name );
    void playerNameIp( QString name, QString ip = "localhost" );
    void showStatus1( QString );
    void showStatus2( QString );

private:
    KornersWidget* m_widget;
};

#endif